Subject: bug#55871: Acknowledgement (27.1; vc-git.el log view 'a', 'f', 'd' do not work when following renames)

From: Eli Zaretskii <[email-masked]>
Date: Fri, 15 Dec 2023 17:10:22 +0200

> Date: Fri, 15 Dec 2023 16:39:04 +0200
> Cc: [email-masked], [email-masked]
> From: Dmitry Gutov <[email-masked]>
> 
> > FYI: 'd' and 'f' work with bzr without any changes.
> 
> To my understanding, Bazaar doesn't really exist in this day and age, so 
> should we pay extra attention to it in this NEWS entry?

Bazaar is still being developed, but I don't know how important it is
nowadays.  I do use it here, FWIW (and keep the old repository under
Bazaar, from before the switch, for the rare occasion I need to look
up or try something there).

> We could say that the problem is relevant to Git and Hg, and the current 
> solution only helps Git. I'm not sure what's the best phrasing, however, 
> which won't bloat the NEWS entry too much.

That'd be fine, and the wording could just use what you say above.

> > 'a' doesn't work
> > (evidently, "bzr annotate -r REVISION FILE" doesn't work when FILE did
> > not exist in REVISION, but was renamed by a later revision, and one
> > needs to run "bzr status -Sr REVISION" and look for the "renamed"
> > report in the result, which will then provide the previous name).
> 
> But when we're asking for 'annotate' for a file in some old revision 
> (under old name), it won't be the same revision where it had been 
> renamed, 99% of the time.

It doesn't matter.  The above-mentioned bzr command will show the
telltale "RM old => new" status.  Keep in mind that "-r REVISION" in
bzr means "since REVISION till the current head".

> > (FTR: I used src/unexcoff.c file to test this.)
> > 
> >> +*** Support for viewing file change history across renames.
> >> +When a fileset's VC change history ends at a rename, we now print the
> >> +old name(s) and a button which jumps to their history.  Only supported
> >> +with Git at the moment.
> > 
> > I think this should at least tell that for files under Bazaar, the VC
> > change history will always include the renames.  Looks like Mercurial
> > is in the same department as Git?
> 
> More or less, yes, here's an even older bug report: 
> https://debbugs.gnu.org/13004
> 
> > If so, I think the text should say
> > that this is not supported for Mercurial yet, and that Bazaar shows
> > the entire history, including renames, by default.  Or something like
> > that.
> 
> I don't want to make it a sticking point, but according to the wiki 
> entry Monotone also tracks renames. We won't be mentioning it here, will we?

vc-monotone is not part of Emacs, right?

It is okay to say "is not yet supported for Hg".